searchData={"items":[{"type":"module","title":"ExAequoKwds","doc":"Tools to handle access and constraints to Keyword Lists \n\n### `check_kwds`\n\nAll required keys are present\n\n    iex(1)> check_kwds([a: 1, b: 2], [:b, :a])\n    {:ok, %{a: 1, b: 2}}\n\nDefaults can be used\n\n    iex(2)> check_kwds([a: 1], [:a, b: 2])\n    {:ok, %{a: 1, b: 2}}\n\nBut might not\n\n    iex(3)> check_kwds([a: 1, b: 1], [:a, b: 2])\n    {:ok, %{a: 1, b: 1}}\n\nWe must not have spurious keys\n\n    iex(4)> check_kwds([a: 1, b: 1], [:a])\n    {:error, \"spurious [b: 1]\"}\n\nNor missing ones\n\n    iex(5)> check_kwds([b: 1], [:a, :b])\n    {:error, \"missing key a\"}\n\nBut we can ignore_errors\n\n    iex(6)> check_kwds([a: 1, b: 1], [:a], ignore_errors: true)\n    {:ok, %{a: 1}}\n\n    iex(7)> check_kwds([b: 1], [:a, :b], ignore_errors: true)\n    {:ok, %{a: nil, b: 1}}\n\n### `check_kwds!`\n\nAll fine or ignoring errors\n\n    iex(8)> check_kwds!([a: 1, b: 2], [:b, :a])\n    %{a: 1, b: 2}\n\n    iex(9)> check_kwds!([a: 1], [:a, b: 2])\n    %{a: 1, b: 2}\n\n    iex(10)> check_kwds!([a: 1, b: 1], [:a], ignore_errors: true)\n    %{a: 1}\n\n    iex(11)> check_kwds!([b: 1], [:a, :b], ignore_errors: true)\n    %{a: nil, b: 1}\n\n Otherwise `ArgumentError` will be raised\n\n    iex(12)> assert_raise(ArgumentError, fn -> check_kwds!([a: 1, b: 1], [:a]) end)\n\nNor missing ones\n\n    iex(13)> assert_raise(ArgumentError, fn -> check_kwds!([b: 1], [:a, :b]) end)","ref":"ExAequoKwds.html"},{"type":"function","title":"ExAequoKwds.check_kwds/3","doc":"","ref":"ExAequoKwds.html#check_kwds/3"},{"type":"function","title":"ExAequoKwds.check_kwds!/3","doc":"","ref":"ExAequoKwds.html#check_kwds!/3"},{"type":"type","title":"ExAequoKwds.result_t/0","doc":"","ref":"ExAequoKwds.html#t:result_t/0"},{"type":"type","title":"ExAequoKwds.single_spec_t/0","doc":"","ref":"ExAequoKwds.html#t:single_spec_t/0"},{"type":"type","title":"ExAequoKwds.spec_t/0","doc":"","ref":"ExAequoKwds.html#t:spec_t/0"},{"type":"module","title":"ExAequoKwds.Types","doc":"All types","ref":"ExAequoKwds.Types.html"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,49]}}